package main

import (
	"go_backend/cmd/config"
	"go_backend/internal/api"
	"go_backend/internal/dbs"
	scheduledtask "go_backend/internal/scheduled_task"
	"go_backend/internal/utils"
	"strconv"

	"github.com/gin-gonic/gin"
	"github.com/robfig/cron/v3"
)

func main() {

	config.InitConfig()

	if config.AllConfig.Database == "init" || config.AllConfig.Database == "Init" {
		println("init!!!!!!")
		dbs.GenerateModel()
	}

	r := gin.Default()

	r.Use(utils.Cors())

	api.GetAllCameras(r.Group(""))
	api.CreateNode(r.Group(""))
	api.ModifyNode(r.Group(""))
	api.CreateDetectionRecord(r.Group(""))
	api.GetDetectionRecord(r.Group(""))
	api.GetTrajectoryRecordList(r.Group(""))
	println(config.AllConfig.Port)

	c := cron.New()
	c.AddFunc("@every 1m", scheduledtask.MergeTrajectory)
	c.Start()

	// _ = r.Run(":" + strconv.Itoa(config.AllConfig.Port))
	_ = r.Run(":" + strconv.Itoa(8080))
}
